/* Name: servidor.h 
   Author: Andr de Castilho
   Date: 03/10/07 23:37
   Description: .H que define a classe Servidor
   
   Mudanas feitas por Simao em maio de 2008
   
*/

#ifndef _SERVIDOR_H_
#define _SERVIDOR_H_

#include <winsock2.h>
#include <windows.h>
#include <process.h>
#include "Lista.h"
#include "Aluno.h"
#include "Professor.h"

//using namespace std;

class Servidor
{
    sockaddr_in meu_end;
    long int cont_msg;
    SOCKET meu_Sockt;
    bool tem_Canal, tem_Sockt, tem_Conexao;
    int max_conexao, bytes_recebidos;  // bytes recebidos, armazena o valor de retorno de recv
    char buffer[500];
    Lista<Aluno> lAlunos;
    Lista<Professor> lProfessor;
    
public:
       
    Servidor(char* ip = "127.0.0.1", unsigned short porta = 3077, int max = 1);
    ~Servidor();
    
    void conectaSockt ();
    
    /*----------------------------------------------------------------------*/
    void aceitaSockt();
    void lacoDeConexao();
    
    /*----------------------------------------------------------------------*/
    void recebeClasse();
    void cadastraAluno();
    void cadastraProfessor(); 
    
};

#endif
