#ifndef _ELEMENTO_H_
#define _ELEMENTO_H_

// Um gabarito se define inteiramente no .h
template<class TIPO>
class Elemento
{
private:
    Elemento<TIPO>*  	proximo;
    Elemento<TIPO>*  	anterior;
    TIPO*             	info;
    char 	           	nome[150];

public:
    Elemento ( );
    ~Elemento ( );

    void setProximo ( Elemento<TIPO>* p );
    Elemento<TIPO>* getProximo ( );

    void setAnterior ( Elemento<TIPO>* a );
    Elemento<TIPO>* getAnterior ( );

    void setInfo ( TIPO* i );
    TIPO* getInfo ( );

    void setNome ( char* n );
    char* getNome ( );
};

template<class TIPO>
Elemento<TIPO>::Elemento ( )
{
   proximo = NULL;  
   anterior = NULL; 
   info = NULL;
}

template<class TIPO>
Elemento<TIPO>::~Elemento ( )
{

}

template<class TIPO>
void Elemento<TIPO>::setProximo ( Elemento<TIPO>* p )
{ 
   proximo = p;
}

template<class TIPO>
Elemento<TIPO>* Elemento<TIPO>::getProximo ( )
{
   return proximo;
}

template<class TIPO>
void Elemento<TIPO>::setAnterior ( Elemento<TIPO>* a )
{
   anterior = a;
}

template<class TIPO>
Elemento<TIPO>* Elemento<TIPO>::getAnterior ( )
{
   return proximo;
}

template<class TIPO>
void Elemento<TIPO>::setInfo ( TIPO* i )
{
   info = i;
}

template<class TIPO>
TIPO* Elemento<TIPO>::getInfo()
{
   return info;
}

template<class TIPO>
void Elemento<TIPO>::setNome ( char*  n )
{
   strcpy ( nome, n );
}

template<class TIPO>
char* Elemento<TIPO>::getNome ()
{
   return nome;
} 
#endif


