/*
  Name: main.cpp 
  Author: Andr de Castilho
  Date: 03/10/07 23:37
  Description: Programa que demonstra a criao e utilizao de uma classe que funciona como um
               servidor bem simples utilizando o protocolo TCP/IP
*/

#include <windows.h>
CRITICAL_SECTION cs;

int iter = 1; // flag que sinaliza o processo de loopConexao 
              // caso o usuario queira sair do programa
              
#include "servidor.h"

void interfaceUsuario(void *param);

main()
{
    Servidor serv(&cs, &iter);
    InitializeCriticalSection(&cs);
    serv.conectaSockt();
    _beginthread(interfaceUsuario, 0, &serv);
    
    serv.aceitaSockt ( );
    serv.lacoDeConexao ( );
    
    WSACleanup(); // fecha portas, socks...
    system("pause");
}

void interfaceUsuario(void *param)
{
    int opc;
    Servidor *serv1;
    serv1 = reinterpret_cast<Servidor *> ( param );   
    while ( iter )
    {
       EnterCriticalSection(&cs);
       cout << "Servidor versao 0.2: " << endl;
       cout << "\tQual sua opcao?" << endl;
       cout << "\t  1 - Listar Alunos" << endl;
       cout << "\t  2 - Listar Professores";
       cout << "\n\t  3 - Sair" << endl;
       LeaveCriticalSection(&cs);
       cin >> opc;
       switch(opc)
       {  case 1: { EnterCriticalSection(&cs);
                    serv1->listaAlunos();
                    cout << endl;
                    system("pause");
                    LeaveCriticalSection(&cs);
                  } break;
          case 2: { EnterCriticalSection(&cs);
                    serv1->listaProfessores();
                    cout << endl;
                    system("pause");
                    LeaveCriticalSection(&cs);
                  } break;
          case 3: { WSACleanup();
                    exit(EXIT_SUCCESS);
                  } break;
          default:{ system("cls");
                  } continue;      
       }
       system("cls");
       Sleep(10);
    }     
}
