/*
  Name: cliente.h 
  Author: Andr de Castilho
  Date: 03/10/07 23:40
  Description: .H que contm a definio da classe Cliente
*/

#ifndef _CLIENTE_H_
#define _CLIENTE_H_

#include <winsock2.h>
#include <windows.h>

#include "Aluno.h"
#include "Pessoa.h"
#include "Professor.h"

class Cliente
{
    sockaddr_in         serv_end;
    
    // OBS: na verdade, nao precisa ser definido o endereo do cliente
    sockaddr_in         meu_end;
    SOCKET              meu_sockt;
    
public:
    Cliente();
    ~Cliente();
    
    /*-----------------------------------------------*/
    // A funo que no recebe parmetros pergunta ao usuario a porta e o ip do server
    void conectar ( char *ip, unsigned short porta );
    void conectar ( );
       
    // Envia uma string de texto
    void enviaString();
    
    // Envia um buffer contendo os dados referentes a um aluno;
    void cadastraAluno (char *nome, int RA, int ID);
    void cadastraProfessor(char *nome, float sal, float bp);
    
    // Rotina principal de envio de dados
    void rotinaPrincipal();
    
     /*----------------------------------------------*/
    // Efetua o bind do socket a uma porta
    //  DESNECESSRIO FAZER ISTO NO CLIENTE
    // void ligaSockt();
};

#endif
